# Construction of a flow sheaf
#
# Copyright (c) 2015, Michael Robinson
# Distribution of unaltered copies permitted for noncommercial use only
# All other uses require express permission of the author
# This software comes with no warrantees express or implied 

import pysheaf as ps
import networkx as nx
import matplotlib.pyplot as plt

# First, get a graph in the workspace
graph=ps.erdosRenyiDirectedGraph(nvert=10,prob=0.5)

# Use graph.skeleton(0) to find vertices
# Use graph.skeleton(0) to find edges

# Build a flow sheaf over the graph
fs=ps.FlowSheaf(graph)

# Examine vertex in/out degrees
print 'Vertex degrees\n'
for v in fs.skeleton(0):
    print 'Vertex: ' + str(v) + ': ' + str(len(fs.cells[v].cofaces))

# Display the graph
G=graph.attachDiagram()
nx.draw(G)
plt.savefig('s2a3.png')
plt.show()
