# Visualize Protein-Protein interactions as a graph
#
# Copyright (c) 2015, Michael Robinson
# Distribution of unaltered copies permitted for noncommercial use only
# All other uses require express permission of the author
# This software comes with no warrantees express or implied 

import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import networkx as nx

# Load the data
dfPP=pd.read_table('baylor_ppi.txt',sep='\t* *')

G=nx.Graph()
for e1 in dfPP['entity1']:
    # Compute the star over this entity
    verts=dfPP['entity1'][dfPP['entity2'][:]==e1]
    verts.append(dfPP['entity2'][dfPP['entity1'][:]==e1])
   
    # Filter out edges that connect within the star
    subgraph=dfPP[['entity1','entity2']][dfPP['entity1'].isin(verts) & dfPP['entity2'].isin(verts)]
    if not subgraph.empty:
        G.add_edges_from(subgraph.values)

nx.draw(G,pos=nx.spring_layout(G))
plt.savefig('s1a5.png')
plt.show()

